<template>
  <!-- 
    普通编辑窗体
    v 1.2
    2021-04-30
    Lufthafen
  -->
  <a-form-model :model="form" :rules="rules" class="yo-form" ref="form">
    <a-spin :spinning="loading">
      <a-icon slot="indicator" spin type="loading" />
      <div class="yo-form-group">
        <!-- 表单控件 -->
        <!-- ... -->
        <a-form-model-item label="角色名" prop="name">
          <a-input placeholder="请输入角色名" v-model="form.name" />
        </a-form-model-item>
        <a-form-model-item :disabled="editDisabled" label="唯一编码" prop="code">
          <a-input placeholder="请输入唯一编码" v-model="form.code" />
        </a-form-model-item>
        <a-form-model-item label="系统参数" prop="sysFlag">
          <a-radio-group :disabled="editDisabled" v-model="form.sysFlag">
            <a-radio-button value="Y">是</a-radio-button>
            <a-radio-button value="N">否</a-radio-button>
          </a-radio-group>
        </a-form-model-item>
        <a-form-model-item label="所属分类" prop="groupCode">
          <a-select :disabled="editDisabled" placeholder="请选择所属分类" v-model="form.groupCode">
            <a-select-option
              :key="i"
              :value="item.code"
              v-for="(item, i) in groupCode"
            >{{ item.value }}</a-select-option>
          </a-select>
        </a-form-model-item>
        <a-form-model-item label="参数值" prop="name">
          <a-input placeholder="请输入参数值 " v-model="form.value" />
        </a-form-model-item>
        <a-form-model-item label="备注" prop="remark">
          <a-input placeholder="请输入备注" v-model="form.remark" />
        </a-form-model-item>
      </div>
    </a-spin>
  </a-form-model>
</template>
<script>
/* 表单内容默认值 */
const defaultForm = {
  /* ... */
};

export default {
  data() {
    return {
      /** 表单数据 */
      form: {},
      /** 验证格式 */
      rules: {
        name: [{ required: true, message: '请输入应用名称' }],
        code: [{ required: true, message: '请输入唯一编码' }],
        sysFlag: [{ required: true, message: '请选择参数类型' }],
        groupCode: [{ required: true, message: '请选择所属分类' }],
        value: [{ required: true, message: '请输入参数值' }],
        /* ... */
      },

      /** 加载异步数据状态 */
      loading: false,
      editDisabled: false,
      groupCode: [],
      /** 其他成员属性 */
      /* ... */
    };
  },

  methods: {
    /**
     * 必要的方法
     * 在打开编辑页时允许填充数据
     */
    onFillData(params) {
      /** 将默认数据覆盖到form */
      this.form = this.$_.cloneDeep({
        ...defaultForm,
        ...params.record,
        /** 在此处添加其他默认数据转换 */
        /* ... */
      });

      this.editDisabled = this.form.sysFlag == 'Y';
    },

    /**
     * 必要方法
     * 验证表单并获取表单数据
     */
    onGetData() {
      return new Promise((reslove, reject) => {
        this.$refs.form.validate((valid) => {
          if (valid) {
            const record = this.$_.cloneDeep(this.form);

            /** 验证通过后可以对数据进行转换得到想要提交的格式 */
            /* ... */

            reslove(record);
          } else {
            reject();
          }
        });
      });
    },

    /**
     * 必要的方法
     * 在外部窗口进行保存时调用表单验证
     */
    onValidate(callback) {
      this.$refs.form.validate(callback);
    },

    /**
     * 必要的方法
     * 在外部窗口关闭或重置时对表单验证进行初始化
     */
    onResetFields() {
      setTimeout(() => {
        this.$refs.form.resetFields();

        /** 在这里可以初始化当前组件中其他属性 */
        /* ... */
      }, 300);
    },

    /**
     * 必要方法
     * 加载当前表单中所需要的异步数据
     */
    async onInit(params) {
      this.loading = true;
      /** 可以在这里await获取一些异步数据 */
      this.groupCode = await this.onLoadgroupCodeData();
      /* ... */
      this.loading = false;
    },

    /** 当前组件的其他方法 */
    /* ... */
    /**
     *
     * 获取所属分类字典表的内容
     */
    onLoadgroupCodeData() {
      return this.$api.sysDictTypeDropDown({ code: 'consts_type' }).then(({ data }) => {
        return data;
      });
    },
  },
};
</script>